// EnumFontTest2.cpp
// Copyright (C) 2019 Katayama Hirofumi MZ (katayama.hirofumi.mz@gmail.com).
// This file is public domain software.
#include <windows.h>
#include <cstdio>
using namespace std;

int CALLBACK
EnumFontsProc(
    const LOGFONTA *plf,
    const TEXTMETRICA *ptm,
    DWORD dwType,
    LPARAM lpData)
{
    printf("%s, %d: %ld\n", plf->lfFaceName, plf->lfCharSet, plf->lfHeight);
    return TRUE;
}

int CALLBACK
EnumFontFamProc(
    const ENUMLOGFONTA *pelf,
    const NEWTEXTMETRICA *ptm,
    DWORD FontType,
    LPARAM lParam)
{
    const LOGFONTA *plf = &pelf->elfLogFont;
    printf("%s (%s), %d: %ld\n", plf->lfFaceName, (const char *)pelf->elfStyle, plf->lfCharSet, plf->lfHeight);
    return TRUE;
}

int CALLBACK
EnumFontFamExProc(
    const ENUMLOGFONTEXA *pelfe,
    const NEWTEXTMETRICEXA *pntme,
    DWORD FontType,
    LPARAM lParam)
{
    const LOGFONTA *plf = &pelfe->elfLogFont;
    printf("%s (%s), %d: %ld\n", plf->lfFaceName, (const char *)pelfe->elfStyle, plf->lfCharSet, plf->lfHeight);
    return TRUE;
}

int main(void)
{
    LOGFONTA lf;
    if (HDC hDC = CreateCompatibleDC(NULL))
    {
        printf("\n---\nEnumFontsA(NULL):\n");
        EnumFontsA(hDC, NULL, EnumFontsProc, 0);

        printf("\n---\nEnumFontsA(Tahoma):\n");
        EnumFontsA(hDC, "Tahoma", EnumFontsProc, 0);

        printf("\n---\nEnumFontFamiliesA(NULL):\n");
        EnumFontFamiliesA(hDC, NULL, (FONTENUMPROCA)EnumFontFamProc, 0);

        printf("\n---\nEnumFontFamiliesA(Tahoma):\n");
        EnumFontFamiliesA(hDC, "Tahoma", (FONTENUMPROCA)EnumFontFamProc, 0);

        printf("\n---\nEnumFontFamiliesExA(DEFAULT_CHARSET, NULL):\n");
        ZeroMemory(&lf, sizeof(lf));
        lf.lfCharSet = DEFAULT_CHARSET;
        lf.lfFaceName[0] = 0;
        EnumFontFamiliesExA(hDC, &lf, (FONTENUMPROCA)EnumFontFamExProc, 0, 0);

        printf("\n---\nEnumFontFamiliesExA(ANSI_CHARSET, NULL):\n");
        ZeroMemory(&lf, sizeof(lf));
        lf.lfCharSet = ANSI_CHARSET;
        lf.lfFaceName[0] = 0;
        EnumFontFamiliesExA(hDC, &lf, (FONTENUMPROCA)EnumFontFamExProc, 0, 0);

        printf("\n---\nEnumFontFamiliesExA(DEFAULT_CHARSET, Tahoma):\n");
        ZeroMemory(&lf, sizeof(lf));
        lf.lfCharSet = DEFAULT_CHARSET;
        lstrcpy(lf.lfFaceName, "Tahoma");
        EnumFontFamiliesExA(hDC, &lf, (FONTENUMPROCA)EnumFontFamExProc, 0, 0);

        printf("\n---\nEnumFontFamiliesExA(ANSI_CHARSET, Tahoma):\n");
        ZeroMemory(&lf, sizeof(lf));
        lf.lfCharSet = ANSI_CHARSET;
        lstrcpy(lf.lfFaceName, "Tahoma");
        EnumFontFamiliesExA(hDC, &lf, (FONTENUMPROCA)EnumFontFamExProc, 0, 0);

        DeleteDC(hDC);
    }
    return 0;
}
